import numeric.*;

public class Exc0201m01 {
	public static void main(String[] args) {
		EquationSolver solver = new EquationSolver();
		solver.setNumIterations(5);
		solver.setTolerance(1E-3);
		Function f = new TestFunction();
		new EquationDemoView("Metoda e biseksionit", solver);
		EquationDemoView.setNumSignificantDigits(10);
		try {
			solver.bisection(f, 0, 2);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

		new EquationDemoView("Metoda e sekants", solver);
		EquationDemoView.setNumSignificantDigits(10);
		try {
			solver.secant(f, 0, 2);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
	}

	private static class TestFunction implements Function {
		public double value(double x) {
			return x*x - 2;
		}
	}
}
