import numeric.*;
public class Exc020305 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		EquationSolver solver = new EquationSolver();
		solver.setTolerance(1E-4);
		Differentiable f = new TestDifferentiable();
		new EquationDemoView(solver);
		try {
			solver.newton(f, Math.PI/4);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
	}

	private static class TestDifferentiable implements Differentiable {
		public double value (double x) {
			return x - 0.8 - 0.2 * Math.sin(x);
		}
		
		public double derivative (double x) {
			return 1 - 0.2 * Math.cos(x);
		}
	}
}
