import numeric.*;

public class Exc100210 {
	public static void main(String[] args) {
		double[] initial = { 10, 0.1, 0.1 };
		SystemSolver solver = new SystemSolver(initial.length);

		// Example 10.1.2
		solver.setTolerance(1E-8);
		solver.setNumIterations(20);
		SystemDemoView.setNumSignificantDigits(8);

		MultivariateFunction[] fi = {
			x -> x[0] * Math.exp(x[1]) + x[2] - 10,
			x -> x[0] * Math.exp(2 * x[1]) + 2 * x[2] - 12,
			x -> x[0] * Math.exp(3 * x[1]) + 3 * x[2] - 15
		};
		MultivariateFunction[][] df = {
			{ x -> Math.exp(x[1]), x -> x[0] * Math.exp(x[1]), x -> 1 },
			{ x -> Math.exp(2 * x[1]), x -> 2 * x[0] * Math.exp(2 * x[1]), x -> 2 },
			{ x -> Math.exp(3 * x[1]), x -> 3 * x[0] * Math.exp(3 * x[1]), x -> 3 }
		};
		DifferentiableVectorValued f = new DifferentiableVectorFunction(fi, df);
		new SystemDemoView("Metoda e Newton-it", solver);
		try {
			solver.newton(f, initial);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

	}
}
