import numeric.*;

public class Exm030106 {
	public static void main(String[] args) {
		double[] x = { 2.0, 2.2, 2.3 };
		TestFunction f = new TestFunction();

		Matrix m = new Matrix(2, x.length);
		for (int j = 0; j < x.length; j++) {
			m.set(0, j, x[j]);
			m.set(1, j, f.value(x[j]));
		}

		double x0 = 2.1;

		Matrix q = AlgebraicPolynomial.neville(x0, m);
		double val = q.get(2, 2);

		MatrixView.setNumSignificantDigits(4);
		new MatrixView(q);
		
		System.out.println("q_22 = " + val);
	}

	private static class TestFunction implements Function {
		public double value(double x) {
			return Math.log(x);
		}
	}
}
