import numeric.*;

public class Exm030201 {
	public static void main(String[] args) {
		double[] x = { 1.0, 1.3, 1.6, 1.9, 2.2 };
		TestFunction f = new TestFunction();

		Matrix m = new Matrix(2, x.length);
		for (int j = 0; j < x.length; j++) {
			m.set(0, j, x[j]);
			m.set(1, j, f.value(x[j]));
		}

		int[] i1 = { 1, 2 },
				i2 = { 1, 2, 3 }, ii2 = { 0, 1, 2 },
				i3 = { 1, 2, 3, 4 }, ii3 = { 0, 1, 2, 3 };

		AlgebraicPolynomial p1 = AlgebraicPolynomial.lagrange(m, i1);
		AlgebraicPolynomial p2 = AlgebraicPolynomial.lagrange(m, i2);
		AlgebraicPolynomial pp2 = AlgebraicPolynomial.lagrange(m, ii2);
		AlgebraicPolynomial p3 = AlgebraicPolynomial.lagrange(m, i3);
		AlgebraicPolynomial pp3 = AlgebraicPolynomial.lagrange(m, ii3);
		AlgebraicPolynomial p4 = AlgebraicPolynomial.lagrange(m);

		new MatrixView("Koeficientt e P_1",
				p1.getCoefficient());
		new MatrixView("Koeficientt e P_2",
				p2.getCoefficient());
		new MatrixView("Koeficientt e PP_2",
				pp2.getCoefficient());
		new MatrixView("Koeficientt e P_3",
				p3.getCoefficient());
		new MatrixView("Koeficientt e PP_3",
				pp3.getCoefficient());
		new MatrixView("Koeficientt e P_4",
				p4.getCoefficient());

		double x0 = 1.5;
		System.out.println("Vlerat e prafrta n " + x0);
		System.out.println("p1(" + x0 + ") = " + p1.value(x0));
		System.out.println("p2(" + x0 + ") = " + p2.value(x0));
		System.out.println("pp2(" + x0 + ") = " + pp2.value(x0));
		System.out.println("p3(" + x0 + ") = " + p3.value(x0));
		System.out.println("pp3(" + x0 + ") = " + pp3.value(x0));
		System.out.println("p4(" + x0 + ") = " + p4.value(x0));
	}

	private static class TestFunction implements Function {
		public double value(double x) {
			double y = 0;
			if (x == 1.0) {
				y = 0.7651977;
			} else if (x == 1.3) {
				y = 0.6200860;
			} else if (x == 1.6) {
				y = 0.4554022;
			} else if (x == 1.9) {
				y = 0.2818186;
			} else if (x == 2.2) {
				y = 0.1103623;
			} else {
				throw new RuntimeException("Undefined function value.");
			}
			return y;
		}
	}
}
