import numeric.*;

public class Exm100102 {
	public static void main(String[] args) {
		double[] initial = { 0.1, 0.1, -0.1 };
		SystemSolver solver = new SystemSolver(initial.length);

		// Example 10.1.2
		solver.setTolerance(1E-8);
		solver.setNumIterations(20);
		SystemDemoView.setNumSignificantDigits(8);

		MultivariateFunction[] component = {
				x -> Math.cos(x[1] * x[2]) / 3.0 + 1.0 / 6.0,
				x -> Math.sqrt(x[0] * x[0] + Math.sin(x[2]) + 1.06) / 9.0 - 0.1,
				x -> -Math.exp(-x[0] * x[1]) / 20.0 - (10 * Math.PI - 3)/60.0
		};
		VectorValued g = new VectorFunction(component);
		new SystemDemoView("Metoda e iterimit me pik fikse", solver);
		try {
			solver.fixedPoint(g, initial);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

	}

//	private static class IterativeFunction implements VectorValued {
//		public double value(int i, double[] x) {
//			double answer = 0;
//			switch (i) {
//			case 0: {
//				answer = Math.cos(x[1] * x[2]) / 3.0 + 1.0 / 6.0;
//				break;
//			}
//			case 1: {
//				answer = Math.sqrt(x[0] * x[0] + Math.sin(x[2]) + 1.06) / 9.0 - 0.1;
//				break;
//			}
//			case 2: {
//				answer = -Math.exp(-x[0] * x[1]) / 20.0
//						- (10 * Math.PI - 3)/60.0;
//				break;
//			}
//			}
//			return answer;
//		}
//	}

}
