/**
 * <p>File: TestRadixFloating.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: June 2007</p>
 * @author Faton M. Berisha
 * @version 2.01
 */

import numeric.RadixFloating;

/**
 * 
 */
public class TestRadixFloating {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
/*		
		double d = 14.625;
		RadixFloating.setDefaultRadix(2);
		RadixFloating.setDefaultNumDigits(53);
		RadixFloating rf1 = new RadixFloating(d);
		RadixFloating rf2 = new RadixFloating(d);
		System.out.println( "Baza: " + rf1.getRadix() );
		System.out.println(d + "\\approx (prafrime t njpasnjshme)");
		rf1.setRounding(RadixFloating.ROUNDING);
		rf2.setRounding(RadixFloating.CHOPPING);
		System.out.println("\t\t\t Me rrumbullakim \t\tMe cungim");
		for ( int i = 7; i > 0; i-- ) {
			rf1.setNumDigits(i);
			rf2.setNumDigits(i);
			System.out.print(i + " shifra t rndsishme: ");
			StringBuffer sb = new StringBuffer("                 ");
			System.out.print(sb.replace(0, rf1.toString().length()-1, rf1.toString()));
			System.out.println("\t\t" + rf2 + "\t" + rf1.toDouble());
			
		}
		System.out.println();

		RadixFloating.setDefaultRadix(10);
		RadixFloating.setDefaultNumDigits(16);
		rf1 = new RadixFloating(d);
		rf2 = new RadixFloating(d);
		System.out.println( "Baza: " + rf1.getRadix() );
		System.out.println(d + "\\approx (prafrime t njpasnjshme)");
		rf1.setRounding(RadixFloating.ROUNDING);
		rf2.setRounding(RadixFloating.CHOPPING);
		System.out.println("\t\t\t Me rrumbullakim \t\tMe cungim");
		for ( int i = 7; i > 0; i-- ) {
			rf1.setNumDigits(i);
			rf2.setNumDigits(i);
			System.out.print(i + " shifra t rndsishme: ");
			StringBuffer sb = new StringBuffer("               ");
			System.out.print(sb.replace(0, rf1.toString().length()-1, rf1.toString()));
			System.out.println("\t\t" + rf2);
			
		}
		System.out.println();
		
		RadixFloating rf = new RadixFloating(1.0/3);
		System.out.println(1.0 + " / " + 3 + " \\approx ");
		System.out.println("Baza " + rf.getRadix() + ": " + rf);
		rf.setNumDigits(33);
		rf.setRadix(3);
		System.out.println("Baza " + rf.getRadix() + ": " + rf);
		System.out.println();
		
*/		
		RadixFloating rf = new RadixFloating(999);
		rf.setNumDigits(2);
		System.out.println("Numri i shifrave t rndsishem " + rf.getNumDigits());
		System.out.println(999 + "\\approx " + rf);
		System.out.println();

		// Shembulli i Binary Floatting Point Arithmetic Standard
		// nga leksioni
		int[] mantissa = new int[53];
		mantissa[0] = mantissa[1] = mantissa[3] = mantissa[4] = 1;
		mantissa[5] = mantissa[8] = mantissa[12] = 1;
		int exponent = 4 + 1;
		rf = new RadixFloating(mantissa, exponent,2);
		System.out.println(rf);
		System.out.println(rf.toDouble());
		// Numri m i vogl i ardhshm
		mantissa[52] = 1;
		rf = new RadixFloating(mantissa, exponent,2);
		System.out.println(rf);
		System.out.println(rf.toDouble());
		// Numri m i madh paraprak
		mantissa[12] = 0;
		for (int i = 13; i < 53; i++) {
			mantissa[i] = 1;
		}
		rf = new RadixFloating(mantissa, exponent,2);
		System.out.println(rf);
		System.out.println(rf.toDouble());
	}

}
