/**
 * <p>File: DifferentiableFunction.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: January 2016</p>
 * @author Faton M. Berisha
 * @version 6.0.0
 */

package numeric;

import java.util.function.*;

public class DifferentiableFunction implements Differentiable {
	private DoubleFunction<Double> f;
	private DoubleFunction<Double> df;
	
	public DifferentiableFunction(DoubleFunction<Double> f,
			DoubleFunction<Double> df) {
		this.f = f;
		this.df = df;
	}

	@Override
	public double value(double x) {
		return f.apply(x);
	}

	@Override
	public double derivative(double x) {
		return df.apply(x);
	}
}
