/**
 * <p>File: DifferentiableMultivariateFunction.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: April 2022</p>
 * @author Faton M. Berisha
 * @version 7.0.0
 */

package numeric;

public class DifferentiableMultivariateFunction
			implements DifferentiableMultivariate {
	
	MultivariateFunction f;
	MultivariateFunction[] df;

	public DifferentiableMultivariateFunction
			(MultivariateFunction f, MultivariateFunction[] df) {
		this.f = f;
		this.df = df;
	}
	
	@Override
	public double value(double[] x) {
		return f.value(x);
	}

	@Override
	public double[] derivative(double[] x) {
		double[] answer = new double[df.length];
		for ( int i = 0; i < answer.length; i++ ) {
			answer[i] = df[i].value(x);
		}
		return answer;
	}
}
